﻿using Microsoft.EntityFrameworkCore;
using UserService.Infrastructure.DataModels;

namespace UserService.DatabaseLayer.DataModels
{
    public class UserServiceDbContext : DbContext
    {
        public DbSet<User> Users { get; set; } = null!;
        public DbSet<SecurityGroup> SecurityGroups { get; set; } = null!;
        public DbSet<UserMember> UserMembers { get; set; } = null!;
        public DbSet<OrganizationUnit> OrganizationUnits { get; set; } = null!;

        protected override void OnConfiguring(DbContextOptionsBuilder options)
            => options.UseSqlite(@"Data Source=C:\Users\holger\Desktop\UserService\UserService.db");

        /// <inheritdoc />
        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.CreateRelations();
            modelBuilder.Seed();
        }
    }
}